#include <stdio.h>
#include "regex.h"


#define PATTERN "^peti.*n$"

int
main(int argc, char **argv)
{
    regex_t   preg;
    char buffer[4096];
    int rc;

    rc = regcomp(&preg, PATTERN, REG_ICASE | REG_NOSUB | REG_NEWLINE);
    if (rc != 0) {
	printf("Failed to compile the regex.");
	exit(1);
    }

    printf("Matching against \"" PATTERN "\".\n");

    while (fgets(buffer, sizeof(buffer), stdin)) {
	if (buffer[strlen(buffer)-1] == '\n')
	  buffer[strlen(buffer)-1] = '\0';
	rc = regexec(&preg, buffer, 0, NULL, 0);

	if (rc != REG_NOMATCH)
	  printf("\"%s\" matches \"%s\".\n", buffer, PATTERN);
	else
	  printf("\"%s\" does not match \"%s\".\n", buffer, PATTERN);
    }



    return 0;
}
