#! /bin/sh

#
# Change into the directory above the one containing this script, so
# that we know the correct paths.
#
cd `echo $0 | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
cd ..

#
# Determine the current version number.
#
VERS=`sed -n -e '/^#define[	 ][	 ]*VERS/p' src/petidomo/version.h | sed -e 's/^.*"\(.*\)"/\1/' -e 's/ /-/g' -e 's/-beta-/b/g'`

#
# Copy the current sources to the temporary directory.
#
mkdir /tmp/petidomo-src
tar -cf - * | (cd /tmp/petidomo-src; tar -xf -)
(
    cd /tmp/petidomo-src
    if [ -f include/petidomo.mk ]; then
	make distclean
    fi
    find . \( \( -name 'CVS' -and -type d \) -or \
	-name '.cvsignore' -or \
	-name '*.o' -or  -name '*.a' -or \
	\( -name 'doc' -and -type d \) \) \
	-print \
	| xargs rm -rf
    ln etc/README README
    ln etc/COPYRIGHT COPYRIGHT
)

#
# Create the release archive.
#
(
    echo Creating $VERS-src.tar.gz
    cd /tmp
    tar -cf $VERS-src.tar petidomo-src
    gzip $VERS-src.tar
)

#
# Clean up
#
rm -rf /tmp/petidomo-src
