/*
 *      $Source: /usr/local/libdata/cvs/simons/petidomo/src/htmlconf/handlelistselect.c,v $
 *      $Revision: 1.8 $
 *      $Date: 1998/06/01 17:19:27 $
 *
 *      Copyright (C) 1996 by Peter Simons, Germany
 *      All rights reserved.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include <cgi.h>
#include <petidomo.h>

extern cgi_info      ci;
extern form_entry *  form_parameter;

void    printMainPage(void);
bool isValidListName(const char *);

const char petidomo_listconf_html[] = \
"<H1 ALIGN=center>Petidomo 2.2 Mailing List Configuration</H1>\n" \
"<H2 ALIGN=right><CODE>%s</CODE></H2>\n" \
\
"<FORM METHOD=\"POST\" ACTION=\"%s\">\n" \
"<INPUT TYPE=hidden NAME=page VALUE=listconf>\n" \
"<INPUT TYPE=hidden NAME=listname VALUE=\"%s\">\n" \
"<INPUT TYPE=hidden NAME=password VALUE=\"%s\">\n" \
\
\
"Please specify the <STRONG>mailing list type</STRONG>: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=radio NAME=listtype VALUE=open %s> open &nbsp; &nbsp; &nbsp;\n" \
"  <INPUT TYPE=radio NAME=listtype VALUE=closed %s> closed  &nbsp; &nbsp; &nbsp;\n" \
"  <INPUT TYPE=radio NAME=listtype VALUE=moderated %s> moderated &nbsp; &nbsp; &nbsp;\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please specify, whether you want to allow <STRONG>public subscriptions</STRONG>: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=radio NAME=allowpubsub VALUE=yes %s> yes &nbsp; &nbsp; &nbsp;\n" \
"  <INPUT TYPE=radio NAME=allowpubsub VALUE=no %s> no &nbsp; &nbsp; &nbsp;\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please specify, whether you want to allow people to subscribe an address <STRONG>not " \
"equal</STRONG> to the address they are mailing from: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=radio NAME=allowaliensub VALUE=yes %s> yes &nbsp; &nbsp; &nbsp;\n" \
"  <INPUT TYPE=radio NAME=allowaliensub VALUE=no %s> no &nbsp; &nbsp; &nbsp;\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please specify, whether you want to allow the <STRONG>MEMBERS</STRONG> command for this list: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=radio NAME=allowmembers VALUE=yes %s> yes &nbsp; &nbsp; &nbsp;\n" \
"  <INPUT TYPE=radio NAME=allowmembers VALUE=no %s> no &nbsp; &nbsp; &nbsp;\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Do you want the list to appear on the publically available\n" \
"<STRONG>index</STRONG> listing? <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=radio NAME=showonindex VALUE=yes %s> yes &nbsp; &nbsp; &nbsp;\n" \
"  <INPUT TYPE=radio NAME=showonindex VALUE=no %s> no &nbsp; &nbsp; &nbsp;\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please specify the (virtual) <STRONG>fully qualified host\n" \
"name</STRONG>, Petidomo should use for this mailing list: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"Hostname\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please specify the <STRONG>administrator password</STRONG> for\n" \
"this mailing list: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=\"password\" NAME=\"adminpassword\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER>\n" \
"Verify:\n" \
"<CENTER>\n" \
"  <INPUT TYPE=\"password\" NAME=\"adminpassword2\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please specify the <STRONG>posting password</STRONG> for this mailing\n" \
"list: <BR>\n" \
\
"<CENTER>\n" \
"  <INPUT TYPE=\"password\" NAME=\"postingpassword\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER>\n" \
"Verify:\n" \
"<CENTER>\n" \
"  <INPUT TYPE=\"password\" NAME=\"postingpassword2\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"What <STRONG>Reply-To field</STRONG> would you like to be inserted\n" \
"into posted articles? Leave the field blank for the default behavior,\n" \
"specify <SAMP>none</SAMP> for no Reply-To at all, or enter an valid\n" \
"address to be used:\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"replyto\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"If you want to use a <STRONG>posting filter</STRONG> for postings\n" \
"delivered through this mailing list, please specify the complete path\n" \
"and name of the script or program:\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"postingfilter\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"Please enter the complete path of the file or direcory, where you would like\n" \
"the posted articles to be <STRONG>archived</STRONG>:\n" \
\
"<CENTER>\n" \
"  <INPUT NAME=\"archivepath\" SIZE=30 VALUE=\"%s\">\n" \
"</CENTER> <P>\n" \
\
"<HR> <P>\n" \
\
"<INPUT TYPE=\"submit\"> <INPUT TYPE=\"reset\">\n" \
"</FORM>\n" \
"</BODY>\n" \
"</HTML>\n";

void
handleListSelect(void)
{
    const struct List_Config * ListConfig;
    char *   password;
    char *   listname;

    /* Determine what the user intended to do. */

    password = parmval(form_parameter, "password");
    listname = parmval(form_parameter, "listname");

    /* Do sanity checks. */

    if (listname == NULL || password == NULL || isValidListName(listname) == FALSE) {
	printMainPage();
	return;
    }

    /* Check the password. */

    if (isValidAdminPassword(password, listname) == FALSE) {
	printMainPage();
	puts("<H3>Permission denied</H1>");
	puts("The password you entered does not authorize you to change");
	printf("the configuration of list <CODE>%s</CODE>.<P>", listname);
	return;
    }

    /* Print the list-config page. */

    ListConfig = getListConfig(listname);
    printf(petidomo_listconf_html, listname, ci.script_name, listname, password,
	   ((ListConfig->listtype == LIST_OPEN) ? "CHECKED" : ""),
	   ((ListConfig->listtype == LIST_CLOSED) ? "CHECKED" : ""),
	   ((ListConfig->listtype == LIST_MODERATED) ? "CHECKED" : ""),
	   ((ListConfig->allowpubsub == TRUE) ? "CHECKED" : ""),
	   ((ListConfig->allowpubsub == FALSE) ? "CHECKED" : ""),
	   ((ListConfig->allowaliensub == TRUE) ? "CHECKED" : ""),
	   ((ListConfig->allowaliensub == FALSE) ? "CHECKED" : ""),
	   ((ListConfig->allowmembers == TRUE) ? "CHECKED" : ""),
	   ((ListConfig->allowmembers == FALSE) ? "CHECKED" : ""),
	   ((ListConfig->showonindex == TRUE) ? "CHECKED" : ""),
	   ((ListConfig->showonindex == FALSE) ? "CHECKED" : ""),
	   ListConfig->fqdn,
	   ((ListConfig->admin_password) ? ListConfig->admin_password : ""),
	   ((ListConfig->admin_password) ? ListConfig->admin_password : ""),
	   ((ListConfig->posting_password) ? ListConfig->posting_password : ""),
	   ((ListConfig->posting_password) ? ListConfig->posting_password : ""),
	   ((ListConfig->reply_to) ? ListConfig->reply_to : ""),
	   ((ListConfig->postingfilter) ? ListConfig->postingfilter : ""),
	   ((ListConfig->archivepath) ? ListConfig->archivepath : ""));
}
